<?php
/**
 * Katvin.ru - Anonymous Links plugin
 * @version 1.0.0
 * @author Eugene Novikov
 * @copyright (C) 2008-2015 by Eugene Novikov (http://www.katvin.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 **/
 
// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla plugin library
jimport('joomla.plugin.plugin');

class plgContentKatAnonymousLinks extends JPlugin {
	
	// Constructor
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );		
		// Define current language
		$this->loadLanguage();
	}

	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		
		// DB params
		$class = $this->params->get('class', 'anonym');
		$all_links = $this->params->get('all_links', 0);
		
		// Define the regular expression		
		if ($all_links) {
			$regex = '#<a[^>]*?[^>]*?>.*?<\/a>#si';
		} else {
			$regex  = '#<a[^>]*?class="' . $class . '".*?[^>]*?>.*?<\/a>#si';
		}
        
        if (!preg_match($regex, $article->text))
        {
            return;
        }
        
        // Detect language
        JPlugin::loadLanguage('plg_content_katanonymouslinks', JPATH_ADMINISTRATOR);
        
        // Replace regular expressions found
        $article->text = preg_replace_callback($regex, array($this, 'replacer'), $article->text);
	}
	
	// FUNCTION START	
	function replacer(&$match) {
		
		// Define a URL link in html code
		$ahref = $match[0];
		
		// Search href attribute
		preg_match('#href="(.*?)"#', $ahref, $url);
		$url = $url[1];
		
		// Exclude domains
		$ex_url = $this->params->get('domain_exclude', '');
		
		if ($ex_url) {
			$ex_url = explode("\n", $ex_url);
			foreach ($ex_url as $ex_url_link) {
				$ex_url_link = trim($ex_url_link);
				if (strpos($url, trim($ex_url_link))) {
					return $ahref;
				}
			}
		}
		
		// Exclude prefix
		$ex_pref = $this->params->get('prefix_exclude', '');
		
		if ($ex_pref) {
			$ex_pref = explode(",",str_replace(" ", "", $ex_pref));
			foreach ($ex_pref as $ex_pref_links) {
				$ex_pref_links = trim($ex_pref_links);
				if(preg_match("/$ex_pref_links+(?=:)/", $ahref)) {
					return $ahref;
				}
			}
		}
		
		// Check out the link for anchor and mailto link
		$is_anchor = strpos($url, '#');
		$is_mailto = strpos($url, 'mailto');
		
		jimport('joomla.enviroment.uri');
		
		if ($is_anchor !== false or $is_mailto !== false or JURI::isInternal($url)) {
			return $ahref; // return original ahref
		}
		
		// Check protocol (prefix) references to the correctness (http://, https://, ftp://)		
		$error_message = $this->params->get('error_message', 0);
		
		if ($error_message) {
		  		
				if ((strpos($url, 'http://') === false) && (strpos($url,'https://') === false) && (strpos($url,'ftp://') === false)) {
					JError::raiseNotice('', JText::_('KATANONYMOUS_LINK_WITHOUT_PREFIX_URL'));
		            return;
				}
		}
		
		// Set returned link to blank
		$link = '';
		$service_url = 'http://katvin.ru/?';		

		// Encode/decode functions		
		$encode = $this->params->get('encode', 1);

		if ($encode) {
	 	$link = str_replace ('href="' . $url . '"', 'href="' . $service_url . base64_encode($url) . '"', $ahref);
		}
		else 
 		{
	 	$link = str_replace('href="' . $url . '"', 'href="' . $service_url . $url . '"', $ahref);
		}
	
		unset($url, $ahref, $service_url);

		// Remove "class" & adding "target" if required
		$remove_class = $this->params->get('remove_class', 0);
		$target_attribute = $this->params->get('target_attribute', 0);
		$class = $this->params->get('class', 'anonym');
		$target = $this->params->get('target_attribute', '');
		$remove_target = '_blank' and '_self' and '_parent' and '_top';
		
		if ($remove_class) {
			// Remove class and empty double spaces
			$link = str_replace(array('class="' . $class . '"', '  '), array('', ' '), $link);
			
			unset($remove_class, $class);
		}
		if ($target_attribute) {
			// Adding target="_blank"
			$link = str_replace(array('target="' . $remove_target . '"', '  '), array('', ' '), $link);			
			$link = preg_replace("/<a(.*?)>/", "<a$1 target=\"$target\">", $link);
		}
		// Return modified link
		return $link;
	}
}
?>